#pragma GCC optimize("Ofast")

#include <stdio.h>
#include <inttypes.h>
#include <stddef.h>


uint_fast64_t height, width, div_cnt, figures_cnt, h, v;


void task(void)
{
	scanf(
		"%" SCNuFAST64 " %" SCNuFAST64 " %" SCNuFAST64 " %" SCNuFAST64,
		&height, &width, &div_cnt, &figures_cnt
	);
	if (figures_cnt == 0) puts("0 0");
	else if (figures_cnt > height * width) puts("-1");
	else
	{
		for (h = 1; h < height + 1; ++h)
		{
			if (figures_cnt % h == 0)
			{
				v = figures_cnt / h;
				if (v <= width && h + v - 2 == div_cnt)
				{
					printf("%" PRIuFAST64 " %" PRIuFAST64 "\n", h - 1, v - 1);
					return;
				}
			}
		}
		puts("-1");
	}
}


int main(void)
{
	int t;
	scanf("%d", &t);
	for (; t > 0; --t)
	{
		task();
	}

	return 0;
}