def task(inp: str):
    height, width, div_cnt, figures_cnt = map(int, inp.split())
    if figures_cnt == 1:
        print(0, 0)
        return
    if figures_cnt > height * width:
        print(-1)
        return

    D = (div_cnt + 2) ** 2 - 4 * figures_cnt
    if D < 0:
        print(-1)
        return
    sqrt_D = int(D ** 0.5)
    if sqrt_D ** 2 != D:
        print(-1)
        return
    x1_doubled = (div_cnt + 2 + sqrt_D)
    x2_doubled = (div_cnt + 2 - sqrt_D)
    if x1_doubled % 2 != 0 or x2_doubled % 2 != 0:
        print(-1)
        return
    x1 = x1_doubled // 2 - 1
    x2 = x2_doubled // 2 - 1
    if x1 < 0 or x2 < 0:
        print(-1)
        return
    min_x = min(x1, x2)
    max_x = max(x1, x2)
    if max_x < height:
        if max_x < width:
            print(min_x, max_x)
            return
        elif min_x < width:
            print(max_x, min_x)
            return
    elif min_x < height:
        if max_x < width:
            print(min_x, max_x)
            return
    print(-1)


for i in range(int(input())):
    task(input())
