def task(inp: str):
    height, width, div_cnt, figures_cnt = map(int, inp.split())
    if figures_cnt == 1:
        print(0, 0)
        return
    if figures_cnt > height * width:
        print(-1)
        return

    D = (div_cnt + 2) ** 2 - 4 * figures_cnt
    if D < 0:
        print(-1)
        return
    sqrt_D = int(D ** 0.5)
    if sqrt_D ** 2 != D:
        print(-1)
        return
    x1_doubled = (div_cnt + 2 + sqrt_D)
    x2_doubled = (div_cnt + 2 - sqrt_D)
    if x1_doubled % 2 != 0 or x2_doubled % 2 != 0:
        print(-1)
        return
    x1 = x1_doubled // 2 - 1
    x2 = x2_doubled // 2 - 1
    if x1 < 0 or x2 < 0:
        print(-1)
        return
    print(min(x1, x2), max(x1, x2))


for i in range(int(input())):
    task(input())
