engines_cnt, min_force = map(int, input().split())

z = [0] * engines_cnt
a = [0] * engines_cnt
b = [0] * engines_cnt


def get_force(x):
    force = 0
    for i in range(engines_cnt):
        force += a[i] * min(x, z[i]) + b[i] * max(x - z[i], 0)
    return force


def lower_bound(func, val, l, r):
    cur = l
    diff = r - l
    step = diff // 2

    while step != 0:
        cur += step
        if func(cur) < val:
            l = cur
            cur += 1
            diff = r - cur
        else:
            diff = l - cur
            r = cur
        step = diff // 2
    
    return cur


for i in range(engines_cnt):
    z[i], a[i], b[i] = map(int, input().split())


# z_sorted = sorted(enumerate(z), key=lambda x: x[1])
z_sorted = sorted(z)

prev_x = 0
flag = False
for x in z_sorted:
    force = get_force(x)

    if force >= min_force:
        flag = True
        break

    prev_x = x

if flag:
    print(lower_bound(get_force, min_force, prev_x, x + 1))
else:
    b_sum = sum(b)
    z_over = (min_force - force) // b_sum + (1 if (min_force - force) % b_sum != 0 else 0)
    print(x + z_over)
